package russotto.jglulx;
class GInstrGen {
    public static class GOpcode {
        public String name;
        public int op_width;
        public int load_operands;
        public int store_operands;
        // assumes store operands strictly follow loads
        GOpcode(){};        GOpcode(String n, int w, int l, int s) {
            name = n;
            op_width = w;
            load_operands = l;            store_operands = s;        };
    };

    public final int OP_NOP = 0x0;
    public final int OP_ADD = 0x10;
    public final int OP_SUB = 0x11;
    public final int OP_MUL = 0x12;
    public final int OP_DIV = 0x13;
    public final int OP_MOD = 0x14;
    public final int OP_NEG = 0x15;
    public final int OP_BITAND = 0x18;
    public final int OP_BITOR = 0x19;
    public final int OP_BITXOR = 0x1a;
    public final int OP_BITNOT = 0x1b;
    public final int OP_SHIFTL = 0x1c;
    public final int OP_SSHIFTR = 0x1d;
    public final int OP_USHIFTR = 0x1e;
    public final int OP_JUMP = 0x20;
    public final int OP_JZ = 0x22;
    public final int OP_JNZ = 0x23;
    public final int OP_JEQ = 0x24;
    public final int OP_JNE = 0x25;
    public final int OP_JLT = 0x26;
    public final int OP_JGE = 0x27;
    public final int OP_JGT = 0x28;
    public final int OP_JLE = 0x29;
    public final int OP_JLTU = 0x2a;
    public final int OP_JGEU = 0x2b;
    public final int OP_JGTU = 0x2c;
    public final int OP_JLEU = 0x2d;
    public final int OP_CALL = 0x30;
    public final int OP_RETURN = 0x31;
    public final int OP_CATCH = 0x32;
    public final int OP_THROW = 0x33;
    public final int OP_TAILCALL = 0x34;
    public final int OP_COPY = 0x40;
    public final int OP_COPYS = 0x41;
    public final int OP_COPYB = 0x42;
    public final int OP_SEXS = 0x44;
    public final int OP_SEXB = 0x45;
    public final int OP_ALOAD = 0x48;
    public final int OP_ALOADS = 0x49;
    public final int OP_ALOADB = 0x4a;
    public final int OP_ALOADBIT = 0x4b;
    public final int OP_ASTORE = 0x4c;
    public final int OP_ASTORES = 0x4d;
    public final int OP_ASTOREB = 0x4e;
    public final int OP_ASTOREBIT = 0x4f;
    public final int OP_STKCOUNT = 0x50;
    public final int OP_STKPEEK = 0x51;
    public final int OP_STKSWAP = 0x52;
    public final int OP_STKROLL = 0x53;
    public final int OP_STKCOPY = 0x54;
    public final int OP_STREAMCHAR = 0x70;
    public final int OP_STREAMNUM = 0x71;
    public final int OP_STREAMSTR = 0x72;
    public final int OP_GESTALT = 0x100;
    public final int OP_DEBUGTRAP = 0x101;
    public final int OP_GETMEMSIZE = 0x102;
    public final int OP_SETMEMSIZE = 0x103;
    public final int OP_JUMPABS = 0x104;
    public final int OP_RANDOM = 0x110;
    public final int OP_SETRANDOM = 0x111;
    public final int OP_QUIT = 0x120;
    public final int OP_VERIFY = 0x121;
    public final int OP_RESTART = 0x122;
    public final int OP_SAVE = 0x123;
    public final int OP_RESTORE = 0x124;
    public final int OP_SAVEUNDO = 0x125;
    public final int OP_RESTOREUNDO = 0x126;
    public final int OP_PROTECT = 0x127;
    public final int OP_GLK = 0x130;
    public final int OP_GETSTRINGTBL = 0x140;
    public final int OP_SETSTRINGTBL = 0x141;
    public final int OP_GETIOSYS = 0x148;
    public final int OP_SETIOSYS = 0x149;
    public final int OP_LINEARSEARCH = 0x150;
    public final int OP_BINARYSEARCH = 0x151;
    public final int OP_LINKEDSEARCH = 0x152;
    public final int OP_CALLF = 0x160;
    public final int OP_CALLFI = 0x161;
    public final int OP_CALLFII = 0x162;
    public final int OP_CALLFIII = 0x163;
    static GOpcode []opcodes = {
        new GOpcode("nop", 4, 0, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("add", 4, 2, 1 ),
        new GOpcode("sub", 4, 2, 1 ),
        new GOpcode("mul", 4, 2, 1 ),
        new GOpcode("div", 4, 2, 1 ),
        new GOpcode("mod", 4, 2, 1 ),
        new GOpcode("neg", 4, 1, 1 ),
        null,
        null,
        new GOpcode("bitand", 4, 2, 1 ),
        new GOpcode("bitor", 4, 2, 1 ),
        new GOpcode("bitxor", 4, 2, 1 ),
        new GOpcode("bitnot", 4, 1, 1 ),
        new GOpcode("shiftl", 4, 2, 1 ),
        new GOpcode("sshiftr", 4, 2, 1 ),
        new GOpcode("ushiftr", 4, 2, 1 ),
        null,
        new GOpcode("jump", 4, 1, 0 ),
        null,
        new GOpcode("jz", 4, 2, 0 ),
        new GOpcode("jnz", 4, 2, 0 ),
        new GOpcode("jeq", 4, 3, 0 ),
        new GOpcode("jne", 4, 3, 0 ),
        new GOpcode("jlt", 4, 3, 0 ),
        new GOpcode("jge", 4, 3, 0 ),
        new GOpcode("jgt", 4, 3, 0 ),
        new GOpcode("jle", 4, 3, 0 ),
        new GOpcode("jltu", 4, 3, 0 ),
        new GOpcode("jgeu", 4, 3, 0 ),
        new GOpcode("jgtu", 4, 3, 0 ),
        new GOpcode("jleu", 4, 3, 0 ),
        null,
        null,
        new GOpcode("call", 4, 2, 1 ),
        new GOpcode("return", 4, 1, 0 ),
        new GOpcode("catch", 4, 1, 1 ),
        new GOpcode("throw", 4, 2, 0 ),
        new GOpcode("tailcall", 4, 2, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("copy", 4, 1, 1 ),
        new GOpcode("copys", 2, 1, 1 ),
        new GOpcode("copyb", 1, 1, 1 ),
        null,
        new GOpcode("sexs", 4, 1, 1 ),
        new GOpcode("sexb", 4, 1, 1 ),
        null,
        null,
        new GOpcode("aload", 4, 2, 1 ),
        new GOpcode("aloads", 4, 2, 1 ),
        new GOpcode("aloadb", 4, 2, 1 ),
        new GOpcode("aloadbit", 4, 2, 1 ),
        new GOpcode("astore", 4, 3, 0 ),
        new GOpcode("astores", 4, 3, 0 ),
        new GOpcode("astoreb", 4, 3, 0 ),
        new GOpcode("astorebit", 4, 3, 0 ),
        new GOpcode("stkcount", 4, 0, 1 ),
        new GOpcode("stkpeek", 4, 1, 1 ),
        new GOpcode("stkswap", 4, 0, 0 ),
        new GOpcode("stkroll", 4, 2, 0 ),
        new GOpcode("stkcopy", 4, 1, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("streamchar", 4, 1, 0 ),
        new GOpcode("streamnum", 4, 1, 0 ),
        new GOpcode("streamstr", 4, 1, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("gestalt", 4, 2, 1 ),
        new GOpcode("debugtrap", 4, 1, 0 ),
        new GOpcode("getmemsize", 4, 0, 1 ),
        new GOpcode("setmemsize", 4, 1, 1 ),
        new GOpcode("jumpabs", 4, 1, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("random", 4, 1, 1 ),
        new GOpcode("setrandom", 4, 1, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("quit", 4, 0, 0 ),
        new GOpcode("verify", 4, 0, 1 ),
        new GOpcode("restart", 4, 0, 0 ),
        new GOpcode("save", 4, 1, 1 ),
        new GOpcode("restore", 4, 1, 1 ),
        new GOpcode("saveundo", 4, 0, 1 ),
        new GOpcode("restoreundo", 4, 0, 1 ),
        new GOpcode("protect", 4, 2, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("glk", 4, 2, 1 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("getstringtbl", 4, 0, 1 ),
        new GOpcode("setstringtbl", 4, 1, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("getiosys", 4, 0, 2 ),
        new GOpcode("setiosys", 4, 2, 0 ),
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("linearsearch", 4, 7, 1 ),
        new GOpcode("binarysearch", 4, 7, 1 ),
        new GOpcode("linkedsearch", 4, 6, 1 ),
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        null,
        new GOpcode("callf", 4, 1, 1 ),
        new GOpcode("callfi", 4, 2, 1 ),
        new GOpcode("callfii", 4, 3, 1 ),
        new GOpcode("callfiii", 4, 4, 1 ),
    };

    protected final static int MAXOPERANDS = 8;
    protected int opcode;
    protected int opvalues[] = new int[MAXOPERANDS];
    protected int opmodes[] = new int[MAXOPERANDS];
    public void execute()
    throws GlulxException
    {
        switch (opcode) {
        case OP_NOP:
            op_nop();
            break;
        case OP_ADD:
            op_add();
            break;
        case OP_SUB:
            op_sub();
            break;
        case OP_MUL:
            op_mul();
            break;
        case OP_DIV:
            op_div();
            break;
        case OP_MOD:
            op_mod();
            break;
        case OP_NEG:
            op_neg();
            break;
        case OP_BITAND:
            op_bitand();
            break;
        case OP_BITOR:
            op_bitor();
            break;
        case OP_BITXOR:
            op_bitxor();
            break;
        case OP_BITNOT:
            op_bitnot();
            break;
        case OP_SHIFTL:
            op_shiftl();
            break;
        case OP_SSHIFTR:
            op_sshiftr();
            break;
        case OP_USHIFTR:
            op_ushiftr();
            break;
        case OP_JUMP:
            op_jump();
            break;
        case OP_JZ:
            op_jz();
            break;
        case OP_JNZ:
            op_jnz();
            break;
        case OP_JEQ:
            op_jeq();
            break;
        case OP_JNE:
            op_jne();
            break;
        case OP_JLT:
            op_jlt();
            break;
        case OP_JGE:
            op_jge();
            break;
        case OP_JGT:
            op_jgt();
            break;
        case OP_JLE:
            op_jle();
            break;
        case OP_JLTU:
            op_jltu();
            break;
        case OP_JGEU:
            op_jgeu();
            break;
        case OP_JGTU:
            op_jgtu();
            break;
        case OP_JLEU:
            op_jleu();
            break;
        case OP_CALL:
            op_call();
            break;
        case OP_RETURN:
            op_return();
            break;
        case OP_CATCH:
            op_catch();
            break;
        case OP_THROW:
            op_throw();
            break;
        case OP_TAILCALL:
            op_tailcall();
            break;
        case OP_COPY:
            op_copy();
            break;
        case OP_COPYS:
            op_copys();
            break;
        case OP_COPYB:
            op_copyb();
            break;
        case OP_SEXS:
            op_sexs();
            break;
        case OP_SEXB:
            op_sexb();
            break;
        case OP_ALOAD:
            op_aload();
            break;
        case OP_ALOADS:
            op_aloads();
            break;
        case OP_ALOADB:
            op_aloadb();
            break;
        case OP_ALOADBIT:
            op_aloadbit();
            break;
        case OP_ASTORE:
            op_astore();
            break;
        case OP_ASTORES:
            op_astores();
            break;
        case OP_ASTOREB:
            op_astoreb();
            break;
        case OP_ASTOREBIT:
            op_astorebit();
            break;
        case OP_STKCOUNT:
            op_stkcount();
            break;
        case OP_STKPEEK:
            op_stkpeek();
            break;
        case OP_STKSWAP:
            op_stkswap();
            break;
        case OP_STKROLL:
            op_stkroll();
            break;
        case OP_STKCOPY:
            op_stkcopy();
            break;
        case OP_STREAMCHAR:
            op_streamchar();
            break;
        case OP_STREAMNUM:
            op_streamnum();
            break;
        case OP_STREAMSTR:
            op_streamstr();
            break;
        case OP_GESTALT:
            op_gestalt();
            break;
        case OP_DEBUGTRAP:
            op_debugtrap();
            break;
        case OP_GETMEMSIZE:
            op_getmemsize();
            break;
        case OP_SETMEMSIZE:
            op_setmemsize();
            break;
        case OP_JUMPABS:
            op_jumpabs();
            break;
        case OP_RANDOM:
            op_random();
            break;
        case OP_SETRANDOM:
            op_setrandom();
            break;
        case OP_QUIT:
            op_quit();
            break;
        case OP_VERIFY:
            op_verify();
            break;
        case OP_RESTART:
            op_restart();
            break;
        case OP_SAVE:
            op_save();
            break;
        case OP_RESTORE:
            op_restore();
            break;
        case OP_SAVEUNDO:
            op_saveundo();
            break;
        case OP_RESTOREUNDO:
            op_restoreundo();
            break;
        case OP_PROTECT:
            op_protect();
            break;
        case OP_GLK:
            op_glk();
            break;
        case OP_GETSTRINGTBL:
            op_getstringtbl();
            break;
        case OP_SETSTRINGTBL:
            op_setstringtbl();
            break;
        case OP_GETIOSYS:
            op_getiosys();
            break;
        case OP_SETIOSYS:
            op_setiosys();
            break;
        case OP_LINEARSEARCH:
            op_linearsearch();
            break;
        case OP_BINARYSEARCH:
            op_binarysearch();
            break;
        case OP_LINKEDSEARCH:
            op_linkedsearch();
            break;
        case OP_CALLF:
            op_callf();
            break;
        case OP_CALLFI:
            op_callfi();
            break;
        case OP_CALLFII:
            op_callfii();
            break;
        case OP_CALLFIII:
            op_callfiii();
            break;
        }
    }
    public void op_nop()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_add()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_sub()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_mul()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_div()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_mod()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_neg()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_bitand()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_bitor()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_bitxor()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_bitnot()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_shiftl()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_sshiftr()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_ushiftr()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jump()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jz()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jnz()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jeq()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jne()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jlt()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jge()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jgt()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jle()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jltu()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jgeu()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jgtu()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jleu()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_call()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_return()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_catch()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_throw()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_tailcall()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_copy()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_copys()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_copyb()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_sexs()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_sexb()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_aload()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_aloads()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_aloadb()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_aloadbit()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_astore()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_astores()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_astoreb()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_astorebit()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_stkcount()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_stkpeek()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_stkswap()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_stkroll()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_stkcopy()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_streamchar()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_streamnum()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_streamstr()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_gestalt()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_debugtrap()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_getmemsize()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_setmemsize()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_jumpabs()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_random()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_setrandom()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_quit()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_verify()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_restart()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_save()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_restore()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_saveundo()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_restoreundo()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_protect()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_glk()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_getstringtbl()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_setstringtbl()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_getiosys()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_setiosys()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_linearsearch()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_binarysearch()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_linkedsearch()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_callf()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_callfi()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_callfii()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

    public void op_callfiii()
    throws GlulxException
    {
        throw new UnsupportedOperationException();
    }

}
