package russotto.jglulx;
public class GStack
{
    private byte []mestack;
    private int maxbytes;
    private int sp;

    public GStack(long maxbytes)
    {
	this.maxbytes = (int)maxbytes;
	this.mestack = new byte[this.maxbytes];
	this.sp = 0;
    }

    public void pushWord(int theWord)
    {
	mestack[sp++] = (byte)(theWord>>>24);
	mestack[sp++] = (byte)((theWord>>>16)&0xFF);
	mestack[sp++] = (byte)((theWord>>>8)&0xFF);
	mestack[sp++] = (byte)(theWord&0xFF);
    }

    public void pushByte(int theByte)
    {
	mestack[sp++] = (byte)theByte;
    }

    public void pushShort(int theShort)
    {
	mestack[sp++] = (byte)(theShort>>>8);
	mestack[sp++] = (byte)(theShort&0xFF);
    }
    
    public void pad2() {
	if ((sp & 0x1) != 0)
	    mestack[sp++] = 0;
    }
    public void pad4() {
	while ((sp & 0x3) != 0)
	    mestack[sp++] = 0;
    }

    public int getSP() {
	return sp;
    }

    public void setSP(int sp) {
	if (sp > this.sp)
	    throw new IllegalArgumentException("Tried to grow stack by setting sp");
	this.sp = sp;
    }

    public int popByte() {
	return mestack[--sp]&0xFF;
    }
    
    public int popWord() {
	int theWord = popByte();
	theWord |= popByte() << 8;
	theWord |= popByte() << 16;
	theWord |= popByte() << 24;
	return theWord;
    }

    public int popShort() {
	int theShort = popByte();
	theShort |= popByte() << 8;
	return theShort;
    }

    public int peekWordAbs(int addr)
    {
	return ((mestack[addr]&0xFF)<<24) |
	    ((mestack[addr+1]&0xFF)<<16) |
	    ((mestack[addr+2]&0xFF)<<8) |
	    (mestack[addr+3]&0xFF);
    }

    public int peekShortAbs(int addr)
    {
	return ((mestack[addr]&0xFF)<<8) |
	    (mestack[addr+1]&0xFF);
    }

    public int peekByteAbs(int addr)
    {
	return mestack[addr];
    }
    
    public int peekByte(int addr)
    {
	return peekByteAbs(sp - addr - 1);
    }

    public int peekShort(int addr)
    {
	return peekShortAbs(sp - (2*addr) - 2);
    }

    public int peekWord(int addr)
    {
	return peekWordAbs(sp - (4*addr) - 4);
    }

    public void pokeWordAbs(int addr, int theWord)
    {
	mestack[addr++] = (byte)(theWord>>>24);
	mestack[addr++] = (byte)((theWord>>>16)&0xFF);
	mestack[addr++] = (byte)((theWord>>>8)&0xFF);
	mestack[addr] = (byte)(theWord&0xFF);
    }

    public void pokeShortAbs(int addr, int theShort)
    {
	mestack[addr++] = (byte)(theShort>>8);
	mestack[addr] = (byte)(theShort&0xFF);
    }

    public void pokeByteAbs(int addr, int theByte)
    {
	mestack[addr] = (byte)(theByte&0xFF);
    }

    public void pokeWord(int addr, int theByte)
    {
	pokeWordAbs(sp - addr*4 - 4, theByte);
    }

}
