package russotto.jglulx;
import java.util.HashMap;
import glk.*;

class GlulxGlkRegistry implements GlkObjectRegistry, GlkRetainedRegistry
{
    HashMap objects;
    HashMap objectrocks;
    HashMap expectedarrays;
    int objcounter;
    Glulx gm;
    GlkDispatch glkdis;
    
    GlulxGlkRegistry(Glulx gm, GlkDispatch dis) {
	this.gm = gm;
	this.glkdis = dis;
	//	objects = new HashMap();
	objectrocks = new HashMap();
	expectedarrays = new HashMap();
	objcounter = 1;
	dis.gidispatch_set_object_registry(this);
	dis.gidispatch_set_retained_registry(this);
    }

    public Object my_vm_reg_array(Object array, int len, String typecode)
    {
	Object objrock = expectedarrays.get(array);
	expectedarrays.remove(array);
	return objrock;
    }

    public void my_vm_unreg_array(Object obj, int len, String typecode,
                                    Object objrock)
    {
	if ((typecode.indexOf('<') != -1) ||
	    typecode.indexOf('&') != -1) {
	    /* copy-out array */
	    if (objrock == null) 
		//		throw new GlulxException("Unregistered array which wasn't expected");
		Log.log(Log.ERROR, "my_vm_unreg_array", "Unregistered array which wasn't expected");
	    int glulxloc = ((Integer)objrock).intValue();
	    if (typecode.indexOf('I') != -1) {
		int [] ia = (int [])obj;
		for (int i = 0; i < len; i++) {
		    gm.g_memory.writeWord(glulxloc, ia[i]);
		    glulxloc+=4;
		}
	    }
	    else if (typecode.indexOf('C') != -1) {
		byte []ba = (byte [])obj;
		for (int i = 0; i < len; i++) {
		    gm.g_memory.writeByte(glulxloc++, ba[i]);
		}
	    }
	    else
		//		throw new GlulxException("Array of unknown type unregistered");
		Log.log(Log.ERROR, "my_vm_unreg_array", "Array of unknown type unregistered");
	}
    }
    
    void expect_array(Object array, int vmaddr) {
	expectedarrays.put(array, new Integer(vmaddr));
    }

    void clear_expected_arrays() {
	expectedarrays.clear();
    }

    public int glkObjectToGlulxRef(Object glkobject, int objclass) 
    {
	return ((Integer)glkdis.gidispatch_get_objrock(glkobject, objclass)).intValue();
	
    }

    public Object glulxRefToGlkObject(int glulxref, int objclass) 
    {
	return objectrocks.get(new Integer(glulxref));
    }

    public Object my_vm_reg_object(Object obj, int objclass)
    {
	Object objrock = new Integer(objcounter++);
	Log.log(Log.DEBUG, "my_vm_reg_object", "reg " + obj + " " + objclass + " "+ objrock);
	if (objcounter == 0) /* not likely! */
	    objcounter = 1;
	//	objects.put(obj, objrock);
	objectrocks.put(objrock, obj);
	return objrock;
    }

    public void my_vm_unreg_object(Object obj, int objclass, Object objrock)
    {
	Log.log(Log.DEBUG, "my_vm_unreg_object", "unreg " + obj + " " + objclass + " "+ objrock);
	//	objects.remove(obj);
	objectrocks.remove(objrock);
    }
}
