#!/usr/bin/perl
#this reads the opcode table from the GLK spec
while ($ARGV[0] =~ /^-/) {
    $switch = shift @ARGV;
    $development = 1 if $switch =~ /^-d/;
}
while (<>) {
    chop;
    $opnums{$2} = hex($1) if /^<li>(0x[0-9a-fA-F]{1,4}): (.*)/;
    $inpre = 0 if /<\/pre>/;
#    print $_ if $inpre;
    if ($inpre && /^(\w*)( [LS][0-9])*$/) {
	if (defined $opnums{$1}) {
	    $opdescs[$opnums{$1}] = $_;
	    $opnames[$opnums{$1}] = $1;
	}
    }
    $inpre = 1 if /<pre>/;
}

$maxoperands = 0;
print "package russotto.jglulx;\n";
print "abstract " if !$development;
print "class GInstrGen {\n";
print "    public static class GOpcode {\n";
print "        public String name;\n";
print "        public int op_width;\n";
print "        public int load_operands;\n";
print "        public int store_operands;\n";
print "        // assumes store operands strictly follow loads\n";
print "        GOpcode(){};";
print "        GOpcode(String n, int w, int l, int s) {\n";
print "            name = n;\n";
print "            op_width = w;\n";
print "            load_operands = l;";
print "            store_operands = s;";
print "        };\n";
print "    };\n\n";
for $i (0..$#opnames) {
    if (defined $opnames[$i]) {
	printf ("    public final int OP_%s = 0x%x;\n", uc($opnames[$i]), $i);
    }
}

print "    static GOpcode []opcodes = {\n";
for $i (0..$#opdescs) {
    if (defined $opdescs[$i]) {
#	print "$opdescs[$i]";
	$_ = $opdescs[$i];
	@l_ops = /L[0-9]/g;
	@s_ops = /S[0-9]/g;
	$nload = $#l_ops+1;
	$nstore = $#s_ops+1;
	$opwidth = 4;
	$opwidth = 2 if /^copys/;
	$opwidth = 1 if /^copyb/;
	print "        new GOpcode(\"$opnames[$i]\", $opwidth, $nload, $nstore ),";
	if ($maxoperands < ($nload + $nstore)) {
	    $maxoperands = $nload + $nstore;
	}
    }
    else {
	print "        null,";
    }
    print "\n";
}
print "    };\n\n";

print "    protected final static int MAXOPERANDS = $maxoperands;\n";
print "    protected int opcode;\n";
print "    protected int opvalues[] = new int[MAXOPERANDS];\n";
print "    protected int opmodes[] = new int[MAXOPERANDS];\n";

print "    public void execute()\n";
print "    throws GlulxException\n";
print "    {\n";
print "        switch (opcode) {\n";
for $i (0..$#opnames) {
    if (defined $opnames[$i]) {
	print "        case OP_".uc($opnames[$i]).":\n";
	print "            op_".lc($opnames[$i])."();\n";
	print "            break;\n";
    }
}
print "        }\n";
print "    }\n";

for $i (0..$#opnames) {
    if (defined $opnames[$i]) {
	if ($development) {
	    print "    public void op_".lc($opnames[$i])."()\n";
	    print "    throws GlulxException\n";
	    print "    {\n";
	    print "        throw new UnsupportedOperationException();\n";
	    print "    }\n\n";
	}
	else {
	    print "    abstract public void op_".lc($opnames[$i])."()\n";
	    print "    throws GlulxException;\n\n";
	}
    }
}

print "}\n";
